#######################################################
# This stub is autogenerated
########################################################

import trajectory_msgs.msg._JointTrajectory
import pint.util
import PyKDL
import numbers
import typing
import geometry_msgs.msg._Pose
import rospy.rostime
import pint.quantity


class JointsFactory(object, metaclass=type):
	def __getitem__(self, values):
		...
	...

class Joints(object, metaclass=type):
	def copy(self) -> Joints:
		"""
		Creates a copy of the joints object.
		
		:return: Copy of the joints object.
		"""
		...
	def to_list(self) -> typing.List[float]:
		"""
		Convert the joints object to a list of joint positions.
		
		:return: List of the six joint positions.
		"""
		...
	def with_units(self, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None) -> Joints:
		"""
		Adds a unit type to all positions of the joints object. The defaults are
		the native ROS units. In case a joint position already has units, the
		unit type is converted accordingly.
		
		:param angular_unit: Unit type for the angular joint positions.
		:return: The resulting joints object.
		"""
		...
	def without_units(self, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None) -> Joints:
		"""
		Removes units from the joint positions if any. If no unit type is
		specified ROS units are assumed.
		
		:param angular_unit: Unit type for the angular joint positions.
		:return: The resulting joints object.
		"""
		...
	def to_ros_units(self, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None) -> Joints:
		"""
		Converts the joints object to native ROS units, removing the unit type
		if any. This is useful if you want to send the resulting data to a ROS
		service.
		
		:param angular_unit: Unit type for the angular joint positions.
		:return: The resulting joints object.
		"""
		...
	def from_ros_units(self, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None):
		"""
		Converts the joints object from native ROS units to the target units,
		removing the unit type if any.
		
		:param angular_unit: Unit type for the angular joint positions.
		:return: The resulting joints object.
		"""
		...
	def __repr__(self):
		"""
		Automatically created by attrs.
		"""
		...
	def __eq__(self, other):
		...
	def __ne__(self, other):
		"""
		Check equality and either forward a NotImplemented or return the result
		negated.
		"""
		...
	def __lt__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __le__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __gt__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __ge__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __init__(self, j1: float = 0.0, j2: float = 0.0, j3: float = 0.0, j4: float = 0.0, j5: float = 0.0, j6: float = 0.0) -> None:
		...
	def __getstate__(self):
		"""
		Automatically created by attrs.
		"""
		...
	def __setstate__(self, state):
		"""
		Automatically created by attrs.
		"""
		...
	...

class PoseFactory(object, metaclass=type):
	def __getitem__(self, values):
		...
	...

class Pose(object, metaclass=type):
	def copy(self) -> Pose:
		"""
		Creates a copy of the pose object.
		
		:return: A copy of the pose.
		"""
		...
	def to_list(self) -> typing.List[float]:
		"""
		Convert the pose to a list of the coordinates.
		:return: List of the six coordinates.
		"""
		...
	def to_ros_pose(self) -> geometry_msgs.msg._Pose.Pose:
		"""
		Converts the pose object to a native ROS pose.
		
		:return: ROS pose.
		"""
		...
	def to_kdl_frame(self) -> PyKDL.Frame:
		"""
		Converts the pose object to a KDL frame.
		
		:return: KDL frame.
		"""
		...
	def with_units(self, linear_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None) -> Pose:
		"""
		Adds a unit type to all coordinates of the pose. The defaults are the
		native ROS units. In case a coordinate already has units, the unit type
		is converted accordingly.
		
		:param linear_unit: Unit type for linear coordinates.
		:param angular_unit: Unit type for angular coordinates.
		:return: The resulting pose.
		"""
		...
	def without_units(self, linear_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None) -> Pose:
		"""
		Removes units from the coordinates if any. If no unit type is specified
		ROS units are assumed.
		
		:param linear_unit: Unit type for linear coordinates.
		:param angular_unit: Unit type for angular coordinates.
		:return: The resulting pose.
		"""
		...
	def to_ros_units(self, linear_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None) -> Pose:
		"""
		Converts the pose to native ROS units, removing the unit type if any.
		This is useful if you want to send the resulting data to a ROS service.
		
		:param linear_unit: Unit type for linear coordinates.
		:param angular_unit: Unit type for angular coordinates.
		:return: The resulting pose.
		"""
		...
	def from_ros_units(self, linear_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None, angular_unit: typing.Union[str, pint.util.SharedRegistryObject, None] = None):
		"""
		Converts the pose from native ROS units to the target units, removing
		the unit type.
		
		:param linear_unit: Unit type for linear coordinates.
		:param angular_unit: Unit type for angular coordinates.
		:return: The resulting pose.
		"""
		...
	def inverse(self) -> Pose:
		"""
		Creates the inverse of the pose. Useful for calculating offset.
		
		:return: New pose object.
		"""
		...
	def __mul__(self, other: Pose) -> Pose:
		"""
		Use KDL frame multiplication to apply an offset to a pose.
		
		:param other: Other pose.
		:return: New pose object.
		
		.. code-block:: python
		
		new_wp = waypoint_1 * Pose(x=10) # translates waypoint_1 by x=10
		old_wp = new_wp * Pose(x=10).inverse() # translates new_wp back
		"""
		...
	def __repr__(self):
		"""
		Automatically created by attrs.
		"""
		...
	def __eq__(self, other):
		...
	def __ne__(self, other):
		"""
		Check equality and either forward a NotImplemented or return the result
		negated.
		"""
		...
	def __lt__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __le__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __gt__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __ge__(self, other):
		"""
		Automatically created by attrs.
		"""
		...
	def __init__(self, x: typing.Union[numbers.Number, pint.quantity.Quantity] = 0.0, y: typing.Union[numbers.Number, pint.quantity.Quantity] = 0.0, z: typing.Union[numbers.Number, pint.quantity.Quantity] = 0.0, a: typing.Union[numbers.Number, pint.quantity.Quantity] = 0.0, b: typing.Union[numbers.Number, pint.quantity.Quantity] = 0.0, c: typing.Union[numbers.Number, pint.quantity.Quantity] = 0.0, offset: str = '') -> None:
		...
	def __getstate__(self):
		"""
		Automatically created by attrs.
		"""
		...
	def __setstate__(self, state):
		"""
		Automatically created by attrs.
		"""
		...
	...

class RobotProgramError(Exception, metaclass=type):
	...

class MoveError(RobotProgramError, metaclass=type):
	...

class MoveExecutionError(MoveError, metaclass=type):
	def __init__(self, message = None, error_code = None):
		...
	...

class MovePlanningError(MoveError, metaclass=type):
	...

class PathToleranceError(MoveExecutionError, metaclass=type):
	def __init__(self, error_code = None):
		...
	...

class GoalToleranceError(MoveExecutionError, metaclass=type):
	def __init__(self, error_code = None):
		...
	...

class ProbeError(MoveExecutionError, metaclass=type):
	...

class ProbeUnexpectedContactError(ProbeError, metaclass=type):
	def __init__(self, error_code = None):
		...
	...

class ProbeContactAtStartError(ProbeError, metaclass=type):
	def __init__(self, error_code = None):
		...
	...

class ProbeFailedError(ProbeError, metaclass=type):
	def __init__(self, error_code = None):
		...
	...

class PathPilotError(RobotProgramError, metaclass=type):
	def __init__(self, message: str, instance: str):
		...
	...

class PathPilotInstanceNotConnectedError(PathPilotError, metaclass=type):
	...

class PathPilotInstanceNotFoundError(PathPilotError, metaclass=type):
	...

p: PoseFactory

j: JointsFactory

def init_rpl_interpreter(interpreter):
	...

def movel(target: typing.Union[Pose, Joints], a: float = 0.5, v: float = 0.5, probe: int = 0) -> typing.Union[typing.Tuple[int, rospy.rostime.Time, Joints, Pose], None]:
	"""
	Moves the robot end effector in a straight line from the current position to
	the target waypoint. Targets can be local waypoints or global waypoints
	defined as pose or joints.
	
	:param target: target target
	:param v: move velocity scaling factor 0.0 - 1.0
	:param a: move acceleration scaling factor 0.0 - 1.0
	:param probe: specify the probe mode (2-6, or 0 for no probing)
	Probe mode 2: look for rising edge on probe signal (i.e. contact), raise ProbeFailedError if move completes without seeing a rising edge
	Probe mode 3: like mode 2 but does not raise error if move completes without rising edge
	Probe mode 4: like mode 2 but looks for falling edge
	Probe mode 5: like mode 4 but does not raise an error if move completes without falling edge
	Probe mode 6: "retract" mode, ignore falling edges and allow motion while probe signal is active, but raise ProbeUnexpectedContactError if a rising edge is seen
	
	:return: tuple of probe results:
	(probe contact type (0 = no contact, 1 = rising, 2 = falling),
	time of probe contact,
	Joint positions at probe contact,
	End-effector position / orientation pose at probe contact)
	
	**Examples**
	
	.. code-block:: python
	
	movel(waypoint_1)
	movel("global_waypoint_1", a=0.4, v=0.2)
	movel(j[0.764, 1.64, 0.741, 0.433, 0.140, 2.74])
	"""
	...

def movej(target: typing.Union[Pose, Joints], v: float = 1.0, probe: int = 0) -> typing.Union[typing.Tuple[int, rospy.rostime.Time, Joints, Pose], None]:
	"""
	
	Moves the robot end effector to the target waypoint with a joints move.
	Targets can be local waypoints or global waypoints defined as pose or
	joints.
	
	:param target: target target
	:param v: scale factor for velocity (default is full speed)
	:param probe: specify the probe mode (2-6, or 0 for no probing)
	Probe mode 2: look for rising edge on probe signal (i.e. contact), raise ProbeFailedError if move completes without seeing a rising edge
	Probe mode 3: like mode 2 but does not raise error if move completes without rising edge
	Probe mode 4: like mode 2 but looks for falling edge
	Probe mode 5: like mode 4 but does not raise an error if move completes without falling edge
	Probe mode 6: "retract" mode, ignore falling edges and allow motion while probe signal is active, but raise ProbeUnexpectedContactError if a rising edge is seen
	:return: tuple of probe results (for probing mode 2,3,4,5) or None:
	(probe contact type (0 = no contact, 1 = rising, 2 = falling),
	time of probe contact,
	Joint positions at probe contact,
	End-effector position / orientation pose at probe contact)
	
	**Examples**
	
	.. code-block:: python
	
	movej(waypoint_1)
	movej("global_waypoint_1")
	movej(p[0, 100, 0, 90, 20, 0])
	"""
	...

def movef(target: typing.Union[Pose, Joints]) -> None:
	"""
	Free move command.
	
	:param target: target target
	"""
	...

def movec(interim: typing.Union[Pose, Joints], target: typing.Union[Pose, Joints], a: float = 0.5, v: float = 0.5, probe: int = 0) -> typing.Union[typing.Tuple[int, rospy.rostime.Time, Joints, Pose], None]:
	"""
	Circular/Arc move command.
	
	:param interim: interim waypoint
	:param target: target waypoint
	:param v: move velocity scaling factor 0.0 - 1.0
	:param a: move acceleration scaling factor 0.0 - 1.0
	:param probe: specify the probe mode (2-6, or 0 for no probing)
	Probe mode 2: look for rising edge on probe signal (i.e. contact), raise ProbeFailedError if move completes without seeing a rising edge
	Probe mode 3: like mode 2 but does not raise error if move completes without rising edge
	Probe mode 4: like mode 2 but looks for falling edge
	Probe mode 5: like mode 4 but does not raise an error if move completes without falling edge
	Probe mode 6: "retract" mode, ignore falling edges and allow motion while probe signal is active, but raise ProbeUnexpectedContactError if a rising edge is seen
	:return: tuple of probe results (for probing mode 2,3,4,5) or None:
	(probe contact type (0 = no contact, 1 = rising, 2 = falling),
	time of probe contact,
	Joint positions at probe contact,
	End-effector position / orientation pose at probe contact)
	"""
	...

def probel(target: typing.Union[Pose, Joints, str], a: float = 0.5, v: float = 0.1, v_retract: float = 0.1, away: bool = False) -> Pose:
	"""
	Simple probing cycle that returns to the initial pose (regardless of the
	probe result). The sequence is:
	
	1) Linear move at specified vel / accel scale towards the target position
	2) Stop at probe contact, error condition, or motion end
	3) Retract to original position
	4) Raise any errors from the cycle, or return the probe result
	
	:param target: end point of probing motion (probe cycle uses movel internally)
	:param v: move velocity scaling factor 0.0 - 1.0
	:param a: move acceleration scaling factor 0.0 - 1.0
	:param v_retract: velocity scaling factor to use during retract phase
	:param away: Probe towards work (default) if False, otherwise probe away from work
	
	.. note:: assumes mode 2/4 for probing, meaning an error will be thrown if it reaches the end without contact.
	Caller can catch this exception if they want mode 3/5 functionality
	
	**Examples**
	
	.. code-block:: python
	
	contact_pose = probel(probe_goal_pose, a=0.5, v=0.01, v_retract=0.1, away=False)
	
	"""
	...

def get_digital_in(nr_or_name: typing.Union[str, int]) -> bool:
	"""
	Returns the current digital input state.
	
	:param nr_or_name: The number or name of the digital output pin.
	:return: True or False for High and Low.
	
	**Examples**
	
	.. code-block:: python
	
	io_state = get_digital_in("gripper")
	x = get_digital_in(3)
	"""
	...

def set_digital_out(nr_or_name: typing.Union[int, str], state: bool) -> None:
	"""
	Sets a digital output pin to high or low state.
	
	:param nr_or_name: The number or name of the digital output pin.
	:param state: Set to True or False for on and off.
	
	**Examples**
	
	.. code-block:: python
	
	set_digital_out("gripper", True)
	set_digital_out(2, False)
	"""
	...

def sync() -> None:
	"""
	The sync command is used in wait cycles and to force the execution of queued
	move commands.
	"""
	...

def sleep(secs: float) -> None:
	...

def notify(message: str, warning: bool = False, error: bool = False, image_path: str = '', timeout: typing.Union[float, None] = None) -> None:
	"""
	Creates a popup notification message on the robot UI.
	
	The ``message`` argument text is shown to the user.
	
	By default, the message is displayed as informational and thus will not
	block the program flow. The ``warning`` argument shows a warning message,
	which breaks program flow and can be declined by the operator. The ``error``
	argument shows a blocking error message, which aborts the program.
	
	The optional ``image_path`` argument can be used to display an informational
	image along with the message
	
	:param message: Message text to display in the popup.
	:param warning: Set to true if this message is a warning.
	:param error: Set to true if this message is an error message.
	:param image_path: Optional path to an image file to displayed in the popup.
	:param timeout: Optional timeout in seconds.
	
	**Examples**
	
	.. code-block:: python
	
	notify("Hello World!")
	notify("No part found, check the palette.", warning=True)
	notify("This should not happen.", error=True, image_path="./fatal_error.png")
	"""
	...

def input(message: str, default: str = '', image_path: str = '') -> float:
	"""
	Creates a popup input dialog on the robot UI.
	
	The ``message`` argument text is shown to the user.
	
	The ``option`` default argument can be used to set the default input text.
	
	The optional ``image_path`` argument can be used to display an informational
	image along with the message.
	
	:param message: Message text to display in the popup.
	:param default: The default input value.
	:param image_path: Optional path to an image file to displayed in the popup.
	:return: User input text or None if cancelled
	
	**Examples**
	
	.. code-block:: python
	
	user_input = input("How many parts should be made?", default="5")
	n = int(user_input)
	"""
	...

def pathpilot_mdi(command: str, instance: str = '') -> None:
	"""
	Starts an MDI command on the remote PathPilot instance. If no instance
	argument is given, the command is executed on the first connected PathPilot
	instance.
	
	:param command: MDI command to execute.
	:param instance: PathPilot instance on which this command shall be executed.
	
	**Examples**
	
	.. code-block:: python
	
	pathpilot_mdi("G0 X10")
	pathpilot_mdi("G1 Y-5 F300", "right_mill")
	"""
	...

def pathpilot_cycle_start(instance: str = '') -> None:
	"""
	Starts a cycle on the remote PathPilot instance. If no instance argument is
	given, the command is executed on the first connected PathPilot instance.
	
	:param instance: PathPilot instance on which cycle start should be executed.
	
	**Examples**
	
	.. code-block:: python
	
	pathpilot_cycle_start()
	pathpilot_cycle_start("left_mill")
	"""
	...

def get_joint_values() -> Joints:
	"""
	Returns the current joint values.
	
	:return: Current joint values.
	
	**Examples**
	
	.. code-block:: python
	
	joint_value = get_joint_values()
	"""
	...

def get_pose(apply_work_offset: bool = True, apply_tool_offset: bool = True) -> Pose:
	"""
	Returns the current robot pose.
	
	:param apply_work_offset: Applies the active work offset to the world pose.
	:param apply_tool_offset: Applies the active tool offset to the world pose.
	:return: Current robot pose.
	
	**Examples**
	
	.. code-block:: python
	
	current_pose = get_pose()
	"""
	...

def pause(optional: bool = False, active: bool = False) -> None:
	"""
	The pause command pauses the program execution. Equivalent to M01 break.
	
	The ``optional`` states whether the pause is optional or not. Optional pause
	can be enabled in the robot UI by the operator.
	
	:param optional: If this pause is optional or not.
	:param active: When set to true, this indicates an active pause allowing to operator to jog the program.
	
	**Examples**
	
	.. code-block:: python
	
	pause()
	pause(optional=True)
	"""
	...

def set_work_offset(name: str, pose: typing.Union[Pose, str, None] = None, position: typing.Union[Pose, str, None] = None, orientation: typing.Union[Pose, str, None] = None) -> None:
	"""
	Sets a work offset using a pose, position or orientation or clears an offset.
	
	The position and orientation arguments can be combined to overwrite the
	pose’s position or orientation.
	
	:param name: Name of the work offset
	:param pose: Pose to use for the work offset
	:param position: Use the position of this pose to override the position of the pose.
	:param orientation: Use the orientation of this pose to override the orientation of the pose.
	
	**Examples**
	
	.. code-block:: python
	
	set_work_offset("table", p[0, 100, 0, 0, 0, 0])
	set_work_offset("offset_1", waypoint_2, orientation=Pose(a=90))
	set_work_offset("offset_1") # clears offset_1
	"""
	...

def set_tool_offset(name: str, pose: typing.Union[Pose, str] = None, position: typing.Union[Pose, str] = None, orientation: typing.Union[Pose, str] = None) -> None:
	"""
	Sets a tool offset using a pose, position or orientation or clears an offset.
	
	The position and orientation arguments can be combined to overwrite the
	pose’s position or orientation.
	
	:param name: Name of the tool offset
	:param pose: Pose to use for the tool offset
	:param position: Use the position of this pose to override the position of the pose.
	:param orientation: Use the orientation of this pose to override the orientation of the pose.
	
	**Examples**
	
	.. code-block:: python
	
	set_tool_offset("some_tool", p[0, 0, 100, 0, 0, 0])
	set_tool_offset("other_tool", waypoint_2, position=Pose(z=0.1))
	set_tool_offset("other_tool") # clears offset other_tool
	"""
	...

def get_work_offset(name: str) -> typing.Union[Pose, None]:
	"""
	Returns the pose of a work offset.
	
	:param name: Name of the work offset.
	:return: Pose of the work offset.
	:raises TypeError: if no work offset with the name is found
	
	**Examples**
	
	.. code-block:: python
	
	pose = get_work_offset("table")
	"""
	...

def get_tool_offset(name: str) -> typing.Union[Pose, None]:
	"""
	Returns the pose of a tool offset.
	
	:param name: Name of the tool offset.
	:return: Pose of the work offset or None if it does not exist.
	:raises TypeError: if no tool offset with the name is found
	
	**Examples**
	
	.. code-block:: python
	
	pose = get_tool_offset("tool1")
	"""
	...

def change_work_offset(name: typing.Union[str, None]) -> None:
	"""
	Change the currently active work offset. If an empty string or ``None`` is
	used as as the name parameter, the empty work offset *world* becomes active.
	
	:param name: The name of the tool offset to activate or `None` to disable work offsets.
	
	**Examples**
	
	.. code-block:: python
	
	change_work_offset("table")
	change_work_offset(None) # disable any active offsets
	"""
	...

def change_tool_offset(name: typing.Union[str, None]) -> None:
	"""
	Change the currently active tool offset. If an empty string or ``None`` is
	used as as the name parameter, the empty tool offset *none* becomes active.
	
	:param name: The name of the tool offset to activate or `None` to disable tool offsets.
	
	**Examples**
	
	.. code-block:: python
	
	change_tool_offset("table")
	change_tool_offset(None) # disable any active offsets
	"""
	...

def work_offset(pose = None, position = None, orientation = None, world = False):
	"""
	Scoped offset command. Applies a work offset temporarily on top of the
	currently active work offset.
	
	The scoped offset command can be used to automatically switch the active
	offset back to a previous state when the scope is left. Scoped offsets
	can be nested. Scoped offsets are temporary and do not have a name.
	
	:param pose: The offset pose.
	:param position: A pose from which the position is used for the offset.
	:param orientation: A pose from which the orientation is used for the offset.
	:param world: If set to True the offset is absolute.
	
	**Examples**
	
	.. code-block:: python
	
	with work_offset(p[0, 100, 0, 90, 20, 0]): # creates a temporary offset and activates it
	movel(Pose(x=10)) # move x by 10 starting from the offset
	# the active offset automatically reset when the scope is left
	"""
	...

def get_pathpilot_state(instance: str = '') -> str:
	"""
	Returns the current state of a PathPilot instance. If no instance argument
	is given, the command is executed on the first connected PathPilot instance.
	
	Possible states are:
	
	* “disconnected” - Instance disconnected
	* “estop” - Emergency stop active
	* “running” - a program is running
	* “ready” - instance is ready to start program
	* “idle” - instance is idle, no program loaded
	
	:param instance: PathPilot instance on which cycle start should be executed.
	:return: The current PathPilot state.
	
	**Examples**
	
	.. code-block:: python
	
	state = get_pathpilot_instance()
	while get_pathpilot_instance("left_mill") != "ready":
	sleep(0.1)
	"""
	...

def get_global_waypoint(name: str) -> typing.Union[Pose, Joints, None]:
	"""
	Get global waypoint pose or joints value.
	
	:param name: Name of the global waypoint.
	:return: Pose or Joints of the global waypoint or None if it does not exist.
	
	**Examples**
	
	.. code-block:: python
	
	point = get_global_waypoint("point")
	"""
	...

def set_global_waypoint(name: str, value: typing.Union[Pose, Joints]) -> None:
	"""
	Set global waypoint pose or joints value.
	
	:param name: Name of the global waypoint
	:param value: Pose or joints value
	
	**Examples**
	
	.. code-block:: python
	
	set_global_waypoint("point", p[500.0, 0.0, 900.0, 0.0, -90.0, 0.0])
	"""
	...

def set_units(linear: typing.Union[str, pint.util.SharedRegistryObject, None] = None, angular: typing.Union[str, pint.util.SharedRegistryObject, None] = None):
	"""
	Sets the active linear and angular units for the program.
	
	:param linear: Linear/length unit type: m, mm, inch
	:param angular: Angular/rotation unit type: deg, rad
	
	**Examples**
	
	.. code-block:: python
	
	set_units("mm", "deg")
	set_units(linear="in")
	set_units(angular="rad")
	"""
	...

def get_units() -> typing.Tuple[str, str]:
	"""
	Returns the active linear and angular units from the program.
	
	:return: Linear/length unit type and angular/rotation unit type.
	
	**Examples**
	
	.. code-block:: python
	
	linear, angular = get_units()
	"""
	...

def set_path_blending(enable: bool, blend_radius: typing.Union[float, None] = None) -> None:
	"""
	Enables or disables path blending and sets the blend radius.
	
	:param enable: Enable or disable path blending.
	:param blend_radius: The blend radius between moves in meters.
	
	**Examples**
	
	.. code-block:: python
	
	set_path_blending(True, 0.0)  # enable path blending, blend radius 0.0m
	movej(waypoint1)
	movej(waypoint2)
	movej(waypoint3)
	sync()  # moves executed before this command
	set_path_blending(False)  # disable path blending again
	"""
	...

def set_machine_offset(pose: typing.Union[Pose, str], instance: str = '') -> None:
	"""
	Sets the origin offset for the 3D visualization of the PathPilot remote
	machine model.
	
	:param pose:  Pose to use for the machine offset.
	:param instance: Optional machine instance name. If not given, default instance is used.
	
	**Examples**
	
	.. code-block:: python
	
	set_machine_offset(p[0,0,0,90,0,0], "instance")
	set_machine_offset(Pose(x=100))  # sets offset for default instance
	"""
	...

def set_param(name: str, value: object) -> None:
	"""
	Sets a user parameter to a the defined value.
	
	:param name: Parameter name.
	:param value: Value to store.
	
	.. code-block:: python
	
	set_param("my_waypoint", waypoint1)
	"""
	...

def get_param(name: str, default: object = None) -> object:
	"""
	Fetch a stored user parameter.
	
	:param name: Parameter name.
	:param default: Default value return if the parameter is not defined.
	:return: Returns a base Python type, construct rpl types or returns a dict if the parameter is set,
	else returns the default value.
	
	**Examples**
	
	.. code-block:: python
	
	wp = get_param("my_waypoint", Pose())
	"""
	...

def load_trajectory(file_path: str) -> trajectory_msgs.msg._JointTrajectory.JointTrajectory:
	"""
	Loads a raw joint trajectory from a CSV file and returns them in ROS format.
	
	:param file_path: Path of the CSV file.
	:return: A ROS joint trajectory.
	"""
	...

def execute_trajectory(trajectory: trajectory_msgs.msg._JointTrajectory.JointTrajectory, v: float = 1.0, retime: bool = False) -> None:
	"""
	The execute trajectory command executes a ROS JointTrajectory. Before
	running the joint trajectory, the robot moves to the start joint position
	using a joint move command.
	
	:param trajectory: a ROS joint trajectory
	:param v: move velocity scaling factor 0.0 - 1.0
	:param retime: Enable retiming the trajectory to make use of the velocity scaling.
	"""
	...

def save_trajectory(file_path: str, trajectory: trajectory_msgs.msg._JointTrajectory.JointTrajectory) -> None:
	"""
	The save trajectory command saves a joint trajectory to a CSV file.
	
	:param file_path: Path of the CSV file.
	:param trajectory: The joint trajectory to save.
	"""
	...

